<?php

class Chronopost_Chronorelais_Block_Adminhtml_System_Config_Cleanbutton extends Mage_Adminhtml_Block_System_Config_Form_Field {

    protected function _prepareLayout()
    {
        parent::_prepareLayout();
        if (!$this->getTemplate()) {
            $this->setTemplate('chronorelais/config/clean_button.phtml');
        }
        return $this;
    }

    /**
     * Unset some non-related element parameters
     *
     * @param Varien_Data_Form_Element_Abstract $element
     * @return string
     */
    public function render(Varien_Data_Form_Element_Abstract $element)
    {
        $element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }

    /**
     * Get the button and scripts contents
     *
     * @param Varien_Data_Form_Element_Abstract $element
     * @return string
     */
    protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element)
    {
        $originalData = $element->getOriginalData();

        $this->addData(array(
            'button_label' => Mage::helper('chronorelais')->__($originalData['button_label']),
            'html_id' => $element->getHtmlId()
        ));

        return $this->_toHtml();
    }
}