<?php

class Chronopost_Chronorelais_Block_Adminhtml_System_Config_Contracts extends Mage_Adminhtml_Block_System_Config_Form_Field {

    protected function _prepareLayout()
    {
        parent::_prepareLayout();
        if (!$this->getTemplate()) {
            $this->setTemplate('chronorelais/config/contracts.phtml');
        }
        return $this;
    }



    /**
     * Unset some non-related element parameters
     *
     * @param Varien_Data_Form_Element_Abstract $element
     * @return string
     */
    public function render(Varien_Data_Form_Element_Abstract $element)
    {
        //$element->unsScope()->unsCanUseWebsiteValue()->unsCanUseDefaultValue();
        return parent::render($element);
    }

    /**
     * Get the button and scripts contents
     *
     * @param Varien_Data_Form_Element_Abstract $element
     * @return string
     */
    protected function _getElementHtml(Varien_Data_Form_Element_Abstract $element)
    {
        $originalData = $element->getOriginalData();
        $html = parent::_getElementHtml($element);

        $this->addData(array(
            'html' => $html,
            'check_button_label' => Mage::helper('chronorelais')->__($originalData['check_button_label']),
            'new_contract_button_label' => Mage::helper('chronorelais')->__($originalData['new_contract_button_label']),
            'delete_contract_button_label' => Mage::helper('chronorelais')->__($originalData['delete_contract_button_label']),
            'html_id' => $element->getHtmlId(),
            'comment_sub_account' => Mage::helper('chronorelais')->__($originalData['comment_sub_account']),
            'ajax_url' => Mage::getSingleton('adminhtml/url')->getUrl('adminhtml/chronorelais_ajax/checklogin')
        ));

        return $this->_toHtml();
    }
}