<?php
class Chronopost_Chronorelais_Block_Sales_Shipment_Grid_Renderer_Expedition
    extends Mage_Adminhtml_Block_Widget_Grid_Column_Renderer_Action
{

    public function render(Varien_Object $row)
    {
        /** @var Chronopost_Chronorelais_Helper_Data $_helper */
        $_helper = Mage::helper('chronorelais');
        $orderId = $row->getId();
        $html = '';
        $html .= '<form class="form_' . $row->getIncrementId() . '" id="form_' . $orderId . '" action="' . Mage::helper("adminhtml")->getUrl( "adminhtml/chronorelais_sales_impression/print/") . '" method="post">';
        $html .= '<input type="hidden" name="order_id" value="' . $orderId . '" />';
        $html .= '<input type="hidden" id="order_dimensions" class="dimensions container" name="dimensions" value="" />';
        $html .= '<input name="form_key" type="hidden" value="' . Mage::getSingleton("core/session")->getFormKey() . '" />';
        $html .= '<a href="#" />' .
            $_helper->__('Expédition') .
            '</a>';
        $html .= '</form>';

        if(strlen($row->getData("shipment_increment_id")) == 2) { // if no shipment
            return $html;
        }

        $shipmentsIds = preg_replace("/\s+/", "", $row->getData("shipment_increment_id"));
        $shipmentsIds = explode(',', $shipmentsIds);

        if(count($shipmentsIds) > 1) {
            $html = '';
            $cpt = 0;
            foreach ($shipmentsIds as $shipmentId) {
                $nbLT = $_helper->getNumberLTOfShipment($shipmentId);
                $html .= '<form class="form_' . $row->getIncrementId() . '" id="form_' . $shipmentId . '" action="' . Mage::helper("adminhtml")->getUrl( "adminhtml/chronorelais_sales_impression/print/") . '" method="post">';
                $html .= '<input type="hidden" name="shipment_increment_id" value="' . $shipmentId . '" />';
                if($cpt == 0){
                    $html .= '<input type="hidden" id="' . $shipmentId .'_dimensions" name="dimensions" class="dimensions container" value="" />';
                } else {
                    $html .= '<input type="hidden" id="' . $shipmentId .'_dimensions" name="dimensions" class="dimensions" value="" />';
                }
                $html .= '<input name="form_key" type="hidden" value="' . Mage::getSingleton("core/session")->getFormKey() . '" />';
                $html .= '<a href="#" />' .
                    $_helper->__('Expédition') . '_' . $shipmentId .
                    '</a>';
                $html .= '</form>';
                if($nbLT > 1) {
                    $html .= '<a style="display:block;margin-bottom:-10px" href=' . Mage::helper("adminhtml")->getUrl( "adminhtml/chronorelais_sales_impression/print/") . 'shipment_increment_id/' . $shipmentId . '/view/1>' .
                        $_helper->__('Voir') . ' les ' . $nbLT . ' étiquettes' .
                    '</a><br />';
                } elseif($nbLT > 0) {
                    $html .= '<a style="display:block;margin-bottom:-10px" href=' . Mage::helper("adminhtml")->getUrl( "adminhtml/chronorelais_sales_impression/print/") . 'shipment_increment_id/' . $shipmentId . '/view/1>' .
                        $_helper->__('Voir') . ' l\'étiquette' .
                        '</a><br />';
                }
                $cpt++;
            }
        } elseif(count($shipmentsIds) == 1) {
            $shipmentId = $shipmentsIds[0];
            $nbLT = $_helper->getNumberLTOfShipment($shipmentId);
            $html = '<form class="form_' . $row->getIncrementId() . '" id="form_' . $shipmentId . '" action="' . Mage::helper("adminhtml")->getUrl( "adminhtml/chronorelais_sales_impression/print/") . '" method="post">';
            $html .= '<input type="hidden" name="shipment_increment_id" value="' . $shipmentId . '"/>';
            $html .= '<input type="hidden" id="' . $shipmentId .'_dimensions" class="dimensions container" name="dimensions" value=""/>';
            $html .= '<input name="form_key" type="hidden" value="' . Mage::getSingleton("core/session")->getFormKey() . '" />';
            $html .= '<a href="#" />' .
                        $_helper->__('Expédition') .
                    '</a>';
            $html .= '</form>';
            if($nbLT > 1) {
                $html .= '<a style="display:block;margin-bottom:-10px" href=' . Mage::helper("adminhtml")->getUrl( "adminhtml/chronorelais_sales_impression/print/") . 'shipment_increment_id/' . $shipmentId . '/view/1>' .
                    $_helper->__('Voir') . ' les ' . $nbLT . ' étiquettes' .
                    '</a><br />';
            } elseif($nbLT > 0) {
                $html .= '<a style="display:block;margin-bottom:-10px" href=' . Mage::helper("adminhtml")->getUrl( "adminhtml/chronorelais_sales_impression/print/") . 'shipment_increment_id/' . $shipmentId . '/view/1>' .
                    $_helper->__('Voir') . ' l\'étiquette' .
                    '</a><br />';
            }

        }

        return $html;
    }
}
