<?php


class Chronopost_Chronorelais_Helper_Data extends Mage_Core_Helper_Abstract
{
    //Choronorelais settings for productCode
    const CHRONO_POST = '01'; // for France
    const CHRONO_POST_BAL = '58'; // For france avec option BAL
    const CHRONO_EXPRESS = '17'; // for Interantional
    const CHRONORELAIS = '86'; // for Chronorelais
    const CHRONOPOST_C10 = '02'; // for Chronopost C10
    const CHRONOPOST_C18 = '16'; // for Chronopost C18
    const CHRONOPOST_C18_BAL = '2M'; // for Chronopost C18 avec option BAL
    const CHRONOPOST_CClassic = '44'; // for Chronopost CClassic
    const CHRONOPOST_13H = '13H'; // for France
    const CHRONOPOST_13H_BAL = '13H BAL'; // for France BAL
    const CHRONOPOST_C10_STR = '10H'; // for Chronopost C10
    const CHRONOPOST_C18_STR = '18H'; // for Chronopost C18
    const CHRONOPOST_C18_BAL_STR = '18H BAL'; // for Chronopost C18 BAL
    const CHRONOPOST_CClassic_STR = 'CClassic'; // for Chronopost CClassic
    const CHRONOEXPRESS_EI = 'EI'; // for Interantional
    const CHRONORELAIS_PR = 'PR'; // for Chronorelais
    const CHRONOPOST_DEFAULT_COUNTRY = 'FR';
    const CHRONOPOST_TRACKING_URL = 'http://wsshipping.chronopost.fr/shipping/services/getReservedSkybill?reservationNumber={trackingNumber}';

    const CHRONORELAISEUROPE = '49'; // for Chronorelais Europe
    const CHRONORELAISEUROPE_STR = 'PRU'; // for Chronorelais Europe

    const CHRONORELAISDOM = '4P'; // for Chronorelais DOM
    const CHRONORELAISDOM_STR = 'PRDOM'; // for Chronorelais DOM

    const CHRONOPOST_SMD = '4I'; // for Chronopost SAMEDAY
    const CHRONOPOST_SMD_STR = 'SMD'; // for Chronopost SAMEDAY

    const CHRONOPOST_SRDV = '2O'; // for Chronopost Sur Rendez-vous 'O' majuscule et non 0
    const CHRONOPOST_SRDV_STR = 'SRDV'; // for Chronopost Sur Rendez-vous

    const CHRONOPOST_DIM_BAL = '5A'; // for Chronopost Dimanche BAL
    const CHRONOPOST_DIM_BAL_SERVICE = '514'; // for Chronopost Dimanche BAL
    const CHRONOPOST_DIM_BAL_AS = 'B34'; // for Chronopost Dimanche BAL
    const CHRONOPOST_DIM_BAL_STR = 'DBAL'; // for Chronopost Dimanche BAL

    const CHRONOPOST_REVERSE_R = '4R'; // for Chronopost Reverse 9
    const CHRONOPOST_REVERSE_S = '4S'; // for Chronopost Reverse 10
    const CHRONOPOST_REVERSE_T = '4T'; // for Chronopost Reverse 13
    const CHRONOPOST_REVERSE_U = '4U'; // for Chronopost Reverse 18
    const CHRONOPOST_REVERSE_DEFAULT = '01'; // for Chronopost Reverse 18
    const CHRONOPOST_REVERSE_RELAIS_EUROPE = '3T'; // for Chronopost Reverse RelaisEurope

    const CHRONOPOST_REVERSE_R_SERVICE = '885'; // for Chronopost Reverse 9
    const CHRONOPOST_REVERSE_S_SERVICE = '180'; // for Chronopost Reverse 10
    const CHRONOPOST_REVERSE_T_SERVICE = '898'; // for Chronopost Reverse 13
    const CHRONOPOST_REVERSE_U_SERVICE = '835'; // for Chronopost Reverse 18
    const CHRONOPOST_REVERSE_DEFAULT_SERVICE = '226'; // for Chronopost Reverse 18

    // service codes
    const CHRONOPOST_SERVICE_C10 = '179'; // for Chronopost C10
    const CHRONOPOST_SERVICE_C13 = '226'; // for Chronopost 13
    const CHRONOPOST_SERVICE_C18 = '830'; // for Chronopost C18
    const CHRONORELAIS_SERVICE = '848'; // for Chronorelais France
    const CHRONORELAIS_SERVICE_EUROPE = '337'; // for Chronorelais Europe
    const CHRONORELAIS_SERVICE_DOM = '368'; // for Chronorelais DOM
    const CHRONOEXPRESS_SERVICE = '302'; // for Chrono Express
    const CHRONOPOST_SERVICE_CClassic = '101'; // for Chrono Cclassic
    const CHRONOPOST_SERVICE_SAMEDAY = '973'; // for chrono sameday

    // if you are in a period outside thursday 18:00 to friday 15:00, there is no shipping on saturday
    var $SaturdayShippingDays = array(
        'startday' => 'thursday',
        'endday' => 'friday',
        'starttime' => '18:00:00',
        'endtime' => '15:00:00'
    );

    public function isSendingDay()
    {
        $shipping_days = $this->getSaturdayShippingDays();
        $current_date = $this->getCurrentTimeByZone("Europe/Paris", "Y-m-d H:i:s");

        //get timestamps
        $start_timestamp = strtotime($shipping_days['startday'] . " this week " . $shipping_days['starttime']);
        $end_timestamp = strtotime($shipping_days['endday'] . " this week " . $shipping_days['endtime']);
        $current_timestamp = strtotime($current_date);

        $sending_day = false;
        if ($current_timestamp >= $start_timestamp && $current_timestamp <= $end_timestamp) {
            $sending_day = true;
        }

        return $sending_day;
    }

    public function getSaturdayShippingDays()
    {

        $starday = explode(":", $this->getConfigData("chronorelais/saturday/startday"));
        $endday = explode(":", $this->getConfigData("chronorelais/saturday/endday"));

        $saturdayDays = array();
        $saturdayDays['startday'] = (count($starday) == 3 && isset($starday[0])) ? $starday[0] : $this->SaturdayShippingDays['startday'];
        $saturdayDays['starttime'] = (count($starday) == 3 && isset($starday[1])) ? $starday[1] . ':' . $starday[2] . ':00' : $this->SaturdayShippingDays['starttime'];
        $saturdayDays['endday'] = (count($endday) == 3 && isset($endday[0])) ? $endday[0] : $this->SaturdayShippingDays['endday'];
        $saturdayDays['endtime'] = (count($endday) == 3 && isset($endday[1])) ? $endday[1] . ':' . $endday[2] . ':00' : $this->SaturdayShippingDays['endtime'];

        return $saturdayDays;
    }

    public function getConfigData($path, $storeId = null)
    {
        if ($storeId != null) {
            return Mage::getStoreConfig($path, $storeId);
        }
        return Mage::getStoreConfig($path, Mage::app()->getStore());
    }

    public function getCurrentTimeByZone($timezone = "Europe/Paris", $format = "l H:i")
    {
        $d = new DateTime("now", new DateTimeZone($timezone));

        return $d->format($format);
    }

    /**
     * General Shipping configuration
     * @param array $contract
     * @return string
     */
    public function getConfigurationAccountNumber($contract)
    {
        if ($contract) {
            return $contract["number"];
        }
        return '';
    }

    public function getConfigurationSubAccountNumber($contract)
    {
        if ($contract) {
            return $contract["subAccount"];
        }
        return '';
    }

    public function getConfigurationAccountPass($contract)
    {
        if ($contract) {
            return $contract["pass"];
        }
        return '';
    }

    public function getAccountNumberDemo()
    {
        return '19869502';
    }

    public function getAccountPassDemo()
    {
        return '255562';
    }

    public function getCarrierContract($code)
    {
        $contracts = $this->getConfigContracts();
        $numContract = $this->getConfigData('carriers/' . $code . '/contract', $this->_getConfigScopeStoreId());
        $numContract = (!$numContract || count($contracts) - 1 < $numContract) ? 0 : $numContract;
        return $contracts[$numContract];
    }

    public function getCarrierContractId($code)
    {
        return $numContract = $this->getConfigData('carriers/' . $code . '/contract');
    }

    public function getSpecificContract($id, $storeId = null, $websiteCode = null)
    {
        if ($id != null && (int)$id >= 0) {
            $contracts = $this->getConfigContracts(null, $storeId, $websiteCode);
            return $contracts[$id];
        }
        return null;
    }

    public function getConfigurationTrackingViewUrl()
    {
        return $this->getConfigData('chronorelais/shipping/tracking_view_url');
    }

    public function getConfigurationGoogleMapAPIKey()
    {
        return $this->getConfigData('chronorelais/shipping/google_map_api');
    }

    public function getConfigContracts($JSONformat = false, $storeCode = null, $websiteCode = null)
    {
        $store_id = $this->_getConfigScopeStoreId($storeCode, $websiteCode);
        $config = $this->getConfigData('chronorelais/shipping/contracts', $store_id);

        if ($JSONformat) {
            return $config;
        }

        return json_decode($config, true);
    }

    public function _getConfigScopeStoreId($store_code = null, $website_code = null)
    {
        $storeId = Mage_Core_Model_App::ADMIN_STORE_ID;

        $storeCode = ($store_code === null) ? (string)Mage::getSingleton('adminhtml/config_data')->getStore() : $store_code;
        $websiteCode = ($website_code === null) ? (string)Mage::getSingleton('adminhtml/config_data')->getWebsite() : $website_code;
        if ('' !== $storeCode) { // store level
            try {
                $storeId = Mage::getModel('core/store')->load($storeCode)->getId();
            } catch (Exception $ex) {
            }
        } elseif ('' !== $websiteCode) { // website level
            try {
                $storeId = Mage::getModel('core/website')->load($websiteCode)->getDefaultStore()->getId();
            } catch (Exception $ex) {
            }
        }
        return $storeId;
    }

    public function getChronoProductCode($country, $code = '')
    {
        $productcode = '';
        $code = strtolower($code);

        switch ($code) {
            case 'chronorelais' :
                $productcode = static::CHRONORELAIS;
                break;
            case 'chronopost' :
                $productcode = static::CHRONO_POST;
                break;
            case 'chronoexpress' :
                $productcode = static::CHRONO_EXPRESS;
                break;
            case 'chronopostc10' :
                $productcode = static::CHRONOPOST_C10;
                break;
            case 'chronopostc18' :
                $productcode = static::CHRONOPOST_C18;
                break;
            case 'chronopostcclassic' :
                $productcode = static::CHRONOPOST_CClassic;
                break;
            case 'chronorelaiseurope' :
                $productcode = static::CHRONORELAISEUROPE;
                break;
            case 'chronorelaisdom' :
                $productcode = static::CHRONORELAISDOM;
                break;
            case 'chronopostsameday' :
                $productcode = static::CHRONOPOST_SMD;
                break;
            case 'chronopostsrdv' :
                $productcode = static::CHRONOPOST_SRDV;
                break;
            case 'chronopostdimanche' :
                $productcode = static::CHRONOPOST_DIM_BAL;
                break;
            default :
                $productcode = static::CHRONO_POST;
                break;
        }

        return $productcode;
    }

    public function getChronoAsCode($code = '')
    {
        $asCode = '';
        $code = strtolower($code);

        switch ($code) {
            case 'chronopostdimanche' :
                $productcode = static::CHRONOPOST_DIM_BAL_AS;
                break;
            default:
                $productcode = '';
                break;
        }
        return $productcode;
    }

    public function getChronoProductCodeToShipment($code = '')
    {
        $productcode = '';
        $code = strtolower($code);

        switch ($code) {
            case 'chronorelais' :
                $productcode = static::CHRONORELAIS;
                break;
            case 'chronopost' :
                if ($this->getConfigOptionBAL()) {
                    $productcode = static::CHRONO_POST_BAL;
                } else {
                    $productcode = static::CHRONO_POST;
                }
                break;
            case 'chronoexpress' :
                $productcode = static::CHRONO_EXPRESS;
                break;
            case 'chronopostc10' :
                $productcode = static::CHRONOPOST_C10;
                break;
            case 'chronopostc18' :
                if ($this->getConfigOptionBAL()) {
                    $productcode = static::CHRONOPOST_C18_BAL;
                } else {
                    $productcode = static::CHRONOPOST_C18;
                }
                break;
            case 'chronopostcclassic' :
                $productcode = static::CHRONOPOST_CClassic;
                break;
            case 'chronorelaiseurope' :
                $productcode = static::CHRONORELAISEUROPE;
                break;
            case 'chronorelaisdom' :
                $productcode = static::CHRONORELAISDOM;
                break;
            case 'chronopostsameday' :
                $productcode = static::CHRONOPOST_SMD;
                break;
            case 'chronopostsrdv' :
                $productcode = static::CHRONOPOST_SRDV;
                break;
            case 'chronopostdimanche' :
                $productcode = static::CHRONOPOST_DIM_BAL;
                break;
            default :
                $productcode = static::CHRONO_POST;
                break;
        }

        return $productcode;
    }

    public function getConfigOptionBAL()
    {
        return $this->getConfigData('chronorelais/optionbal/enabled');
    }

    public function getChronoProductCodeString($code = '')
    {
        $productcode = '';
        $code = strtolower($code);

        switch ($code) {
            case 'chronorelais' :
                $productcode = static::CHRONORELAIS_PR;
                break;
            case 'chronopost' :
                $productcode = static::CHRONOPOST_13H;
                break;
            case 'chronoexpress' :
                $productcode = static::CHRONOEXPRESS_EI;
                break;
            case 'chronopostc10' :
                $productcode = static::CHRONOPOST_C10_STR;
                break;
            case 'chronopostc18' :
                $productcode = static::CHRONOPOST_C18_STR;
                break;
            case 'chronopostcclassic' :
                $productcode = static::CHRONOPOST_CClassic_STR;
                break;
            case 'chronorelaiseurope' :
                $productcode = static::CHRONORELAISEUROPE_STR;
                break;
            case 'chronorelaisdom' :
                $productcode = static::CHRONORELAISDOM_STR;
                break;
            case 'chronopostsameday' :
                $productcode = static::CHRONOPOST_SMD_STR;
                break;
            case 'chronopostsrdv' :
                $productcode = static::CHRONOPOST_SRDV_STR;
                break;
            default :
                $productcode = static::CHRONOPOST_13H;
                break;
        }

        return $productcode;
    }

    public function getChronoProductCodeStringWithBAL($code = '')
    {
        $productcode = '';
        $code = strtolower($code);

        switch ($code) {
            case 'chronorelais' :
                $productcode = static::CHRONORELAIS_PR;
                break;
            case 'chronopost' :
                if ($this->getConfigOptionBAL()) {
                    $productcode = static::CHRONOPOST_13H_BAL;
                } else {
                    $productcode = static::CHRONOPOST_13H;
                }
                break;
            case 'chronoexpress' :
                $productcode = static::CHRONOEXPRESS_EI;
                break;
            case 'chronopostc10' :
                $productcode = static::CHRONOPOST_C10_STR;
                break;
            case 'chronopostc18' :
                if ($this->getConfigOptionBAL()) {
                    $productcode = static::CHRONOPOST_C18_BAL_STR;
                } else {
                    $productcode = static::CHRONOPOST_C18_STR;
                }
                break;
            case 'chronopostcclassic' :
                $productcode = static::CHRONOPOST_CClassic_STR;
                break;
            case 'chronorelaiseurope' :
                $productcode = static::CHRONORELAISEUROPE_STR;
                break;
            case 'chronorelaisdom' :
                $productcode = static::CHRONORELAISDOM_STR;
                break;
            case 'chronopostsrdv' :
                $productcode = static::CHRONOPOST_SRDV_STR;
                break;
            case 'chronopostdimanche' :
                $productcode = static::CHRONOPOST_DIM_BAL_STR;
                break;
            default :
                $productcode = static::CHRONOPOST_13H;
                break;
        }

        return $productcode;
    }

    public function getChronoProductCodeWithBAL($code = '')
    {
        $productcode = '';
        $code = strtolower($code);

        switch ($code) {
            case 'chronorelais' :
                $productcode = static::CHRONORELAIS_PR;
                break;
            case 'chronopost' :
                if ($this->getConfigOptionBAL()) {
                    $productcode = static::CHRONOPOST_13H_BAL;
                } else {
                    $productcode = static::CHRONOPOST_13H;
                }
                break;
            case 'chronoexpress' :
                $productcode = static::CHRONOEXPRESS_EI;
                break;
            case 'chronopostc10' :
                $productcode = static::CHRONOPOST_C10;
                break;
            case 'chronopostc18' :
                if ($this->getConfigOptionBAL()) {
                    $productcode = static::CHRONOPOST_C18_BAL;
                } else {
                    $productcode = static::CHRONOPOST_C18;
                }
                break;
            case 'chronopostcclassic' :
                $productcode = static::CHRONOPOST_CClassic;
                break;
            case 'chronorelaiseurope' :
                $productcode = static::CHRONORELAISEUROPE;
                break;
            case 'chronorelaisdom' :
                $productcode = static::CHRONORELAISDOM;
                break;
            case 'chronopostsrdv' :
                $productcode = static::CHRONOPOST_SRDV;
                break;
            case 'chronopostdimanche' :
                $productcode = static::CHRONOPOST_DIM_BAL;
                break;
            default :
                $productcode = static::CHRONOPOST_13H;
                break;
        }

        return $productcode;
    }

    public function getConfigurationTrackingUrl()
    {
        return static::CHRONOPOST_TRACKING_URL;
    }

    /**
     * Export configuration
     */
    public function getConfigurationFileExtension($export_type = 'css')
    {
        return $this->getConfigData('chronorelais/export_' . $export_type . '/file_extension');
    }

    public function getConfigurationFileCharset($export_type = 'css')
    {
        return $this->getConfigData('chronorelais/export_' . $export_type . '/file_charset');
    }

    public function getConfigurationEndOfLineCharacter($export_type = 'css')
    {
        return $this->getConfigData('chronorelais/export_' . $export_type . '/endofline_character');
    }

    public function getConfigurationFieldDelimiter($export_type = 'css')
    {
        return $this->getConfigData('chronorelais/export_' . $export_type . '/field_delimiter');
    }

    public function getConfigurationFieldSeparator($export_type = 'css')
    {
        return $this->getConfigData('chronorelais/export_' . $export_type . '/field_separator');
    }

    /**
     * Import configuration
     */
    public function getConfigurationSendEmail()
    {
        return $this->getConfigData('chronorelais/import/send_email');
    }

    public function getConfigurationIncludeComment()
    {
        return $this->getConfigData('chronorelais/import/include_comment');
    }

    public function getConfigurationDefaultTrackingTitle()
    {
        return $this->getConfigData('chronorelais/import/default_tracking_title');
    }

    public function getConfigurationShippingComment()
    {
        return $this->getConfigData('chronorelais/import/shipping_comment');
    }

    /**
     * Shipper Information
     */
    public function getConfigurationShipperInfo($field)
    {
        $fieldValue = '';
        if ($field && $this->getConfigData('chronorelais/shipperinformation/' . $field)) {
            $fieldValue = $this->getConfigData('chronorelais/shipperinformation/' . $field);
        }

        return $fieldValue;
    }

    /**
     * Chronopost Customer Information
     */
    public function getConfigurationCustomerInfo($field)
    {
        $fieldValue = '';
        if ($field && $this->getConfigData('chronorelais/customerinformation/' . $field)) {
            $fieldValue = $this->getConfigData('chronorelais/customerinformation/' . $field);
        }

        return $fieldValue;
    }

    /**
     * Chronopost Customer Information
     */
    public function getConfigurationReturnInfo($field)
    {
        $fieldValue = '';
        if ($field && $this->getConfigData('chronorelais/returninformation/' . $field)) {
            $fieldValue = $this->getConfigData('chronorelais/returninformation/' . $field);
        }

        return $fieldValue;
    }

    /*
     * Weight unit
     */

    /**
     * Import configuration
     */
    public function getConfigurationSkybillParam()
    {
        if ($mode = $this->getConfigData('chronorelais/skybillparam/mode')) {
            return $mode;
        }
        return 'PDF';
    }

    /*
     * Option BAL
     */

    public function getConfigWeightUnit()
    {
        return $this->getConfigData('chronorelais/weightunit/unit');
    }

    public function hasOptionBAL($order)
    {
        $shippingMethod = explode('_', $order->getShippingMethod());
        $shippingMethod = $shippingMethod[1];
        $shippingMethodAllowBAL = array('chronopost', 'chronopostc18');
        if (in_array(strtolower($shippingMethod), $shippingMethodAllowBAL) && $this->getConfigOptionBAL()) {
            return true;
        }

        return false;
    }

    /*
     * Assurance Ad Valorem
     */
    public function assuranceAdValoremEnabled()
    {
        return $this->getConfigData('chronorelais/assurance/enabled');
    }

    public function assuranceAdValoremAmount()
    {
        return $this->getConfigData('chronorelais/assurance/amount');
    }

    public function getMaxAdValoremAmount()
    {
        return 20000;
    }

    /* Get Livraison le Samedi status by orderid */

    public function getLivraisonSamediStatus($order_id)
    {
        $_connection = Mage::getSingleton('core/resource')->getConnection('core_write');
        $_table = Mage::getSingleton('core/resource')->getTableName('sales_chronopost_order_export_status');
        $select = $_connection->select()
            ->from($_table, 'livraison_le_samedi')
            ->where('order_id=?', $order_id);
        $status = $_connection->fetchOne($select);

        return $status;
    }

    public function getContractOfOrder($order_id)
    {
        $_connection = Mage::getSingleton('core/resource')->getConnection('core_write');
        $_table = Mage::getSingleton('core/resource')->getTableName('chronopost_chronorelais_contracts_orders');
        $select = $_connection->select()
            ->from($_table)
            ->where('order_id=?', $order_id);
        $result = $_connection->fetchRow($select);

        return $result;
    }

    public function saveContractOfOrder($orderId, $contractId)
    {
        if (!$this->getContractOfOrder($orderId)) {
            /** @var Chronopost_Chronorelais_Helper_Data $helper */
            $helper = Mage::helper('chronorelais');
            $contract = $helper->getSpecificContract($contractId);
            if (!$contract) {
                return false;
            }
            $resource = Mage::getSingleton('core/resource');
            $write = $resource->getConnection('core_write');
            $table = $resource->getTableName('chronopost_chronorelais_contracts_orders');

            $write->insert(
                $table,
                [
                    'order_id' => $orderId,
                    'contract_name' => $contract["name"],
                    'contract_account_number' => $contract["number"],
                    'contract_sub_account_number' => $contract["subAccount"],
                    'contract_account_password' => $contract["pass"]
                ]
            );
        }

        return true;
    }

    public function deleteContractOfOrder($orderId)
    {

        $resource = Mage::getSingleton('core/resource');
        $write = $resource->getConnection('core_write');
        $table = $resource->getTableName('chronopost_chronorelais_contracts_orders');

        $write->delete(
            $table,
            ['order_id IN (?)' => [$orderId]]
        );
    }


    /*
     * Return true si la méthode de livraison fait partie du contrat du marchant
     */
    public function shippingMethodEnabled($shippingMethod, $contractId = null, $storeId = null, $websiteId = null)
    {
        if ($contractId != null) {
            $contract = $this->getSpecificContract($contractId, $storeId, $websiteId);
        } else {
            $contract = $this->getCarrierContract($shippingMethod);
        }

        $accountNumber = $this->getConfigurationAccountNumber($contract);
        $pass = $this->getConfigurationAccountPass($contract);

        $WSParams = array(
            'accountNumber' => $accountNumber,
            'password' => $pass,
            'depCountryCode' => $this->getConfigurationShipperInfo('country'),
            'depZipCode' => $this->getConfigurationShipperInfo('zipcode'),
            'arrCountryCode' => $this->getConfigurationShipperInfo('country'),
            'arrZipCode' => $this->getConfigurationShipperInfo('zipcode'),
            'arrCity' => $this->getConfigurationShipperInfo('city'),
            'type' => 'M',
            'weight' => 1
        );

        $helperWS = Mage::helper('chronorelais/webservice');
        $webservbt = $helperWS->checkLogin($WSParams);


        if (!$webservbt->return->errorCode) {

            // recupération des codes produits internationaux
            $products = $webservbt->return->productList;
            $WSParams['arrCountryCode'] = 'ES';
            $WSParams['arrZipCode'] = '28013';
            $WSParams['arrCity'] = 'ES';

            $webservbt = $helperWS->checkLogin($WSParams);

            if (!$webservbt->return->errorCode) {
                if ($productsInter = $webservbt->return->productList) {
                    if (is_array($products)) {
                        $products = array_merge($products, $productsInter);
                    } else {
                        array_push($products, $productsInter->productCode);
                    }
                }
            }

            if (is_array($products)) {
                foreach ($products as $product) {
                    if ($this->getChronoProductCode(null, $shippingMethod) == $product->productCode) {
                        return true;
                    }
                }
            } else {
                if ($this->getChronoProductCodeToShipment($shippingMethod) == $products->productCode) {
                    return true;
                }
            }
        }
        return false;
    }

    /*
    * Return true if we can show google map
    */
    public function canShowGoogleMap()
    {
        return $this->getConfigData('carriers/chronorelais/show_google_map');
    }

    /* return track number field name */
    public function getTrackNumberFieldName()
    {
        if (version_compare(Mage::getVersion(), '1.5.1.0', '>')) {
            return "track_number";
        } else {
            return "number";
        }

    }

    public function addMargeToQuickcost($quickcost_val, $carrierCode = '', $firstPassage = true)
    {
        if ($carrierCode) {

            $quickcostMarge = Mage::getStoreConfig('carriers/' . $carrierCode . '/quickcost_marge');
            $quickcostMargeType = Mage::getStoreConfig('carriers/' . $carrierCode . '/quickcost_marge_type');

            if ($quickcostMarge) {
                if ($quickcostMargeType == 'amount') {
                    $quickcost_val += $quickcostMarge;
                } elseif ($quickcostMargeType == 'prcent') {
                    $quickcost_val += $quickcost_val * $quickcostMarge / 100;
                }
            }
        }

        return $quickcost_val;
    }

    /* Calcul codePruct and codeService for Reverse (return) */
    public function getReturnProductCode($adress, $contract = null)
    {
        $helperData = Mage::helper('chronorelais/webservice');
        $productCodes = $helperData->getMethods($adress, $contract);

        $productReturnCodes = $this->getReturnProductCodesAllowed($productCodes);
        sort($productReturnCodes, SORT_STRING);

        foreach ($this->getMatriceReturnCode() as $code => $combinaisonCodes) {
            if (in_array($productReturnCodes, $combinaisonCodes)) {
                return $code;
            }
        }

        return static::CHRONOPOST_REVERSE_DEFAULT;
    }

    protected function getReturnProductCodesAllowed($productCodes)
    {
        $possibleReturnProductCode = array(
            static::CHRONOPOST_REVERSE_R,
            static::CHRONOPOST_REVERSE_S,
            static::CHRONOPOST_REVERSE_T,
            static::CHRONOPOST_REVERSE_U,
            static::CHRONOPOST_REVERSE_RELAIS_EUROPE
        );
        $returnProductCode = array();
        foreach ($productCodes as $code) {
            if (in_array($code, $possibleReturnProductCode)) {
                array_push($returnProductCode, $code);
            }

            if ($code == static::CHRONORELAISEUROPE) {
                array_push($returnProductCode, self::CHRONOPOST_REVERSE_RELAIS_EUROPE);
            }

        }

        return (sizeof($returnProductCode) > 0) ? $returnProductCode : array(static::CHRONOPOST_REVERSE_DEFAULT);

    }

    public function getReturnServiceCode($code)
    {
        switch ($code) {
            case static::CHRONOPOST_REVERSE_R:
                return static::CHRONOPOST_REVERSE_R_SERVICE;
                break;
            case static::CHRONOPOST_REVERSE_S:
                return static::CHRONOPOST_REVERSE_S_SERVICE;
                break;
            case static::CHRONOPOST_REVERSE_T:
                return static::CHRONOPOST_REVERSE_T_SERVICE;
                break;
            case static::CHRONOPOST_REVERSE_U:
                return static::CHRONOPOST_REVERSE_U_SERVICE;
                break;
            case static::CHRONOPOST_REVERSE_DEFAULT:
                return static::CHRONOPOST_REVERSE_DEFAULT_SERVICE;
                break;
            default :
                return static::CHRONOPOST_REVERSE_DEFAULT_SERVICE;
                break;
        }
    }

    public function getMatriceReturnCode()
    {
        return array(
            static::CHRONOPOST_REVERSE_R => array(
                array(static::CHRONOPOST_REVERSE_R),
                array(static::CHRONOPOST_REVERSE_R, static::CHRONOPOST_REVERSE_U)
            ),
            static::CHRONOPOST_REVERSE_S => array(
                array(static::CHRONOPOST_REVERSE_S),
                array(static::CHRONOPOST_REVERSE_R, static::CHRONOPOST_REVERSE_S),
                array(static::CHRONOPOST_REVERSE_S, static::CHRONOPOST_REVERSE_U),
                array(static::CHRONOPOST_REVERSE_R, static::CHRONOPOST_REVERSE_S, static::CHRONOPOST_REVERSE_U)
            ),
            static::CHRONOPOST_REVERSE_U => array(
                array(static::CHRONOPOST_REVERSE_U)
            ),
            static::CHRONOPOST_REVERSE_RELAIS_EUROPE => array(
                array(static::CHRONOPOST_REVERSE_RELAIS_EUROPE)
            ),
            static::CHRONOPOST_REVERSE_T => array(
                array(static::CHRONOPOST_REVERSE_T),
                array(static::CHRONOPOST_REVERSE_R, static::CHRONOPOST_REVERSE_T),
                array(static::CHRONOPOST_REVERSE_S, static::CHRONOPOST_REVERSE_T),
                array(static::CHRONOPOST_REVERSE_T, static::CHRONOPOST_REVERSE_U),
                array(static::CHRONOPOST_REVERSE_R, static::CHRONOPOST_REVERSE_S, static::CHRONOPOST_REVERSE_T),
                array(static::CHRONOPOST_REVERSE_R, static::CHRONOPOST_REVERSE_T, static::CHRONOPOST_REVERSE_U),
                array(static::CHRONOPOST_REVERSE_S, static::CHRONOPOST_REVERSE_T, static::CHRONOPOST_REVERSE_U),
                array(
                    static::CHRONOPOST_REVERSE_R,
                    static::CHRONOPOST_REVERSE_S,
                    static::CHRONOPOST_REVERSE_T,
                    static::CHRONOPOST_REVERSE_U
                )
            ),
            static::CHRONOPOST_REVERSE_DEFAULT => array(
                array(static::CHRONOPOST_REVERSE_DEFAULT)
            )
        );
    }

    public function getChronoServiceProductCode($code = '')
    {
        $code = strtolower($code);

        switch ($code) {
            case 'chronorelais' :
                $productcode = static::CHRONORELAIS_SERVICE;
                break;
            case 'chronopost' :
                $productcode = static::CHRONOPOST_SERVICE_C13;
                break;
            case 'chronoexpress' :
                $productcode = static::CHRONOEXPRESS_SERVICE;
                break;
            case 'chronopostc10' :
                $productcode = static::CHRONOPOST_SERVICE_C10;
                break;
            case 'chronopostc18' :
                $productcode = static::CHRONOPOST_SERVICE_C18;
                break;
            case 'chronopostcclassic' :
                $productcode = static::CHRONOPOST_SERVICE_CClassic;
                break;
            case 'chronorelaiseurope' :
                $productcode = static::CHRONORELAIS_SERVICE_EUROPE;
                break;
            case 'chronorelaisdom' :
                $productcode = static::CHRONORELAIS_SERVICE_DOM;
                break;
            case 'chronopostsameday' :
                $productcode = static::CHRONOPOST_SERVICE_SAMEDAY;
                break;
            default :
                $productcode = static::CHRONOPOST_SERVICE_C13;
                break;
        }

        return $productcode;
    }

    public function getNumberLTOfShipment($shipmentIncrementId)
    {
        $shipment = Mage::getModel('sales/order_shipment')->getCollection()
            ->addFieldToFilter('increment_id', $shipmentIncrementId)
            ->getFirstItem();

        return count($shipment->getAllTracks());
    }

    public function getWeightOfOrder($orderId)
    {
        $order = Mage::getModel('sales/order')->load($orderId);
        $totalWeight = 0;
        foreach ($order->getAllVisibleItems() as $item) {
            $totalWeight += $item->getWeight() * $item->getQtyOrdered();
        }

        return $totalWeight;
    }

    public function getChronoPreciseSlotsPrice()
    {
        $_wsHelper = Mage::helper('chronorelais/webservice');
        $contract = $this->getCarrierContract('chronopostsrdv');
        $datas = [];
        $datas['accountNumber'] = $contract["number"];
        $datas['password'] = $contract["pass"];

        $url = "https://www.chronopost.fr/quickcost-cxf/QuickcostServiceWS?wsdl";
        if (preg_match('/local/', $_SERVER['HTTP_HOST']) ||
            preg_match('/chronopost.adexos.fr/', $_SERVER['HTTP_HOST'])
        ) {
            $datas['accountNumber'] = "10132603";
            $datas['password'] = "425523";
            $url = "https://wwwpfi.chronopost.fr/quickcost-cxf/QuickcostServiceWS?wsdl";
        }

        $datas['depCode'] = $this->getConfigurationShipperInfo('zipcode');
        $datas['arrCode'] = $this->getConfigurationShipperInfo('zipcode');
        $datas['weight'] = 1;
        $datas['productCode'] = self::CHRONOPOST_SRDV;
        $datas['type'] = 'M';

        $wsReturn = $_wsHelper->getQuickcost($datas, $url);

        if (!$wsReturn->errorCode && $wsReturn->amountTTC) {
            return $wsReturn->amountTTC;
        }

        return 0;
    }

    public function isQuickcostEnabled($code)
    {
        return $this->getConfigData('carriers/' . $code . '/quickcost');
    }

    public function getMaxWeightAuthorized($code)
    {
        if ($code == 'chronorelaiseurope' || $code == 'chronorelais') {
            return 20;
        } else {
            return 30;
        }
    }

    public function getLibelleGmap($label)
    {
        return $this->getConfigData('chronorelais/traductions_gmap/libelle_' . $label, $this->_getConfigScopeStoreId());
    }

    public function returnAuthorized($countryId)
    {
        $csvName = $this->getConfigFilePath('countriesAuthorized.csv');
        $countriesIdsAuthorized = [];

        if (($handle = fopen($csvName, "r")) !== false) {
            while (($data = fgetcsv($handle, 1000, ",")) !== false) {
                foreach ($data as $id) {
                    array_push($countriesIdsAuthorized, $id);
                }
            }

            fclose($handle);
        }

        return in_array($countryId, $countriesIdsAuthorized);
    }

    public function getConfigFilePath($name)
    {
        return Mage::getModuleDir('', 'Chronopost_Chronorelais') . '/config/' . $name;
    }

    public function getContractsHtml($order)
    {
        $_helper = Mage::helper('chronorelais');
        $orderId = $order->getId();

        if ($contract = $_helper->getContractOfOrder($orderId)) {
            $html = '<select name="select_contract_' . $orderId . '" style="display:none">';
            $html .= '<option value="-1" selected="selected">' . $contract["contract_name"] . '</option>';
            $html .= '</select>';
            $html .= '<span>' . $contract["contract_name"] . '</span>';
            return $html;
        } else {
            $html = '<select name="contract">';
            $chronoShippingMethod = strtolower(str_replace(' ', '', $order->getShippingMethod()));
            $chronoShippingMethod = preg_replace('/.*\_/', '', $chronoShippingMethod);
            $contractShippingMethod = $_helper->getCarrierContract($chronoShippingMethod);
            $contracts = $_helper->getConfigContracts();
            foreach ($contracts as $id => $contract) {
                if ($_helper->getConfigurationAccountNumber($contract) == $_helper->getConfigurationAccountNumber($contractShippingMethod)) {
                    $html .= '<option value="' . $id . '" selected="selected">' . $contract["name"] . '</option>';
                } else {
                    $html .= '<option value="' . $id . '">' . $contract["name"] . '</option>';
                }
            }
            $html .= '</select>';

            return $html;
        }
    }

    /**
     * @param $order
     * @return int|mixed
     */
    public function getOrderAdValorem($order)
    {
        $totalAdValorem = 0;

        if ($this->assuranceAdValoremEnabled()) {
            $minAmount = $this->assuranceAdValoremAmount();
            $maxAmount = $this->getMaxAdValoremAmount();

            $items = $order->getAllItems();

            $totalAdValorem = 0;

            foreach ($items as $item) {
                $totalAdValorem += $item->getPrice() * $item->getQtyOrdered();
            }

            $totalAdValorem = min($totalAdValorem, $maxAmount);
            if ($totalAdValorem < $minAmount) {
                $totalAdValorem = 0;
            }
        }

        return $totalAdValorem * 100;
    }
}
