Event.observe(window, 'load', function () {

    Function.prototype.debounce = function (delay) {
        var fn = this;
        return function () {
            fn.args = arguments;
            fn.timeout_id && clearTimeout(fn.timeout_id);
            fn.timeout_id = setTimeout(function () {
                return fn.apply(fn, fn.args)
            }, delay)
        }
    };

    var tds = $$('#sales_order_grid_table tr td.shipment_ids');
    tds.each(function (item) {
        var chaine = item.innerHTML.replace(/^\s+/g, '').replace(/\s+$/g, '');
        var formExpedition = $(item).next('.etiquette_expedition').down('form');
        var lienRetour = $(item).next('.etiquette_retour').down('a');
        var selected_option = $(item).next('.contract_expedition').down('select option:selected');
        var contractId = selected_option ? selected_option.value : -1;
        var weight = $(item).next('.weight_input').down('input').value;
        $(item).next('.number_parcel').down('input').setAttribute('value', 1);
        var nb_parcel = $(item).next('.number_parcel').down('input').value;

        $(item).next('.length_input').down('input').setAttribute('value', 1);
        $(item).next('.width_input').down('input').setAttribute('value', 1);
        $(item).next('.height_input').down('input').setAttribute('value', 1);

        $(item).next('.length_input').down('input').setAttribute('position', 1);
        $(item).next('.width_input').down('input').setAttribute('position', 1);
        $(item).next('.height_input').down('input').setAttribute('position', 1);
        $(item).next('.weight_input').down('input').setAttribute('position', 1);

        $(item).next('.length_input').down('input').setStyle({marginBottom: '5px'});
        $(item).next('.width_input').down('input').setStyle({marginBottom: '5px'});
        $(item).next('.height_input').down('input').setStyle({marginBottom: '5px'});

        var carrier = $(item).next('.shipping_method').innerHTML.trim().toLowerCase().replace(/ /g, '');
        var limitWeight;
        var limitInputsDimensions;
        var limitTotalDimensions;
        if(carrier == 'chronorelaiseurope' || carrier == 'chronorelais'){
            limitWeight = 20;
            limitInputsDimensions = 100;
            limitTotalDimensions = 250;
        } else {
            limitWeight = 30;
            limitInputsDimensions = 150;
            limitTotalDimensions = 300;
        }

        setSubmitFormFunction();
        //correctDimensions(1);

        if (chaine.split(', ').length > 1) {
            var contentRetour = '';
            var numbers = chaine.split(', ');
            for (var i = 0; i < numbers.length; i++) {
                contentRetour += '<a href="' + lienRetour.href.replace(/\/order_id\/\d+\//, '/shipment_increment_id/' + numbers[i] + '/') + '">Retour SAV ' + numbers[i] + '</a><br />';
                formExpedition = $(item).next('.etiquette_expedition').down('#form_' + numbers[i]);
                formExpedition.action = formExpedition.action + 'contract_id/' + contractId + '/number_parcel/' + nb_parcel + '/';
                formExpedition.down('#' + numbers[i] + '_dimensions').value = buildDimensionsObject(item);
            }

            if (typeof lienRetour !== 'undefined') {
                lienRetour.up().innerHTML = contentRetour;
            }
        }
        else if (chaine.length > 2) {
            formExpedition.action = formExpedition.action + 'contract_id/' + contractId + '/number_parcel/' + nb_parcel + '/';
            formExpedition.down('#' + chaine + '_dimensions').value = buildDimensionsObject(item);
            if (typeof lienRetour !== 'undefined') {
                lienRetour.up().innerHTML = '<a href="' + lienRetour.href.replace(/\/order_id\/\d+\//, '/shipment_increment_id/' + chaine + '/') + '">Retour SAV</a><br />';
            }
        }
        else {
            formExpedition.action = formExpedition.action + 'contract_id/' + contractId + '/number_parcel/' + nb_parcel + '/';
            formExpedition.down('#order_dimensions').value = buildDimensionsObject(item);
            if (typeof lienRetour !== 'undefined') {
                lienRetour.up().innerHTML = '';
            }
        }
        if ($(item).next('.contract_expedition').down('select')) {
            $(item).next('.contract_expedition').down('select').on('change', function () {
                var contractId = $(item).next('.contract_expedition').down('select option:selected').value;
                var formExpedition = $(item).next('.etiquette_expedition').down('form');
                formExpedition.action = formExpedition.action.replace(/\/contract_id\/\d+\//g, '/contract_id/' + contractId + '/');
            });
        }

        $(item).next('.number_parcel').down('input').on('keyup', function (e) {
            var formExpedition = $(item).next('.etiquette_expedition').down('form');
            if (isNaN(parseInt(e.key))) {
                e.target.value = e.target.value.replace(/\D/g, '');
                if (!isNaN(e.target.value) || e.target.value !== '') {
                    if(e.target.value == 0) {
                        updateNbInputs(1, weight);
                    } else {
                        updateNbInputs(e.target.value, weight);
                    }
                }
            } else {
                if (e.target.value > 100) {
                    e.target.value = 100;
                }
                if (e.target.value !== '') {
                    if(e.target.value == 0) {
                        updateNbInputs(1, weight);
                    } else {
                        updateNbInputs(e.target.value, weight);
                    }
                }
            }
            do {
                formExpedition.action = formExpedition.action.replace(/\/number_parcel\/\d*\//g, '/number_parcel/' + e.target.value + '/');
                formExpedition.down('.dimensions').value = buildDimensionsObject(item);
                formExpedition = formExpedition.next('form');
            } while (formExpedition);
        }.debounce(200));

        $(item).next('.weight_input').childElements().forEach(function (e) {
            setEventChange(e);
        });
        $(item).next('.width_input').childElements().forEach(function (e) {
            setEventChange(e);
        });
        $(item).next('.height_input').childElements().forEach(function (e) {
            setEventChange(e);
        });
        $(item).next('.length_input').childElements().forEach(function (e) {
            setEventChange(e);
        });

        function setEventChange(e) {
            e.on('change', function (_input) {
                _input.target.value = _input.target.value.replace(/\D/g, '');
                var position = _input.target.readAttribute('position');
                if(!correctDimensions(true)) {
                    return false;
                }
                var formExpedition = $(item).next('.etiquette_expedition').down('form');
                do {
                    formExpedition.down('.dimensions').value = buildDimensionsObject(item);
                    formExpedition = formExpedition.next('form');
                } while (formExpedition);
            });
        }

        function correctDimensions(printError) {
            var inputsToCheck = $(item).up().querySelectorAll('input[position]');
            var orderId = $(item).up().down('.order_id').innerHTML.trim();
            var errorLimitWeight = checkWeightLimit(inputsToCheck);
            var errorDimensions = checkDimensionsLimit(inputsToCheck);
            var errorGlobalDimensions = checkGlobalDimensions(inputsToCheck);

            if(errorLimitWeight) {
                if(printError) {
                    addLiErrorDimensions(orderId, 'weight', limitWeight, limitInputsDimensions, limitTotalDimensions);
                }
            } else {
                removeLiErrorDimensions(orderId, 'weight');
            }

            if(errorLimitWeight === false && errorDimensions) {
                if(printError) {
                    addLiErrorDimensions(orderId, 'length', limitWeight, limitInputsDimensions, limitTotalDimensions);
                }
            } else {
                removeLiErrorDimensions(orderId, 'length');
            }

            if(errorLimitWeight === false && errorDimensions === false && errorGlobalDimensions) {
                if(printError) {
                    addLiErrorDimensions(orderId, 'global', limitWeight, limitInputsDimensions, limitTotalDimensions);
                }
            } else {
                removeLiErrorDimensions(orderId, 'global');
            }

            return (!errorLimitWeight && !errorDimensions && !errorGlobalDimensions);

        }

        function checkWeightLimit(inputs) {
            var error = false;
            inputs.forEach(function(input) {
                if(input.readAttribute('name') === 'weight_input') {
                    if (input.value > limitWeight) {
                        error = true;
                    }
                }
            });
            return error;
        }

        function checkDimensionsLimit(inputs) {
            var error = false;
            inputs.forEach(function(input) {
                if(input.readAttribute('name') !== 'weight_input') {
                    if (input.value > limitInputsDimensions) {
                        error = true;
                    }
                }
            });

            return error;
        }

        function checkGlobalDimensions(inputsToCheck) {
            var error = false;
            var nbLines = inputsToCheck[inputsToCheck.length - 1].readAttribute('position');
            var totalDimensions;
            for (var i = 1; i <= nbLines ; i++) {
                totalDimensions = 0;
                var inputs = $(item).up().querySelectorAll('input[position="'+ i +'"]');
                inputs.forEach(function(input) {
                    if(input.readAttribute('name') !== 'weight_input') {
                        if (input.readAttribute('name') === 'length_input') {
                            totalDimensions += parseInt(input.value);
                        } else {
                            totalDimensions += 2 * parseInt(input.value);
                        }
                    }
                });
                if (totalDimensions > limitTotalDimensions) {
                    error = true;
                }
            }
            return error;
        }

        function updateNbInputs(nbAsked, weight) {
            var weightInputs = item.next('.weight_input');
            var widthInputs = item.next('.width_input');
            var heightInputs = item.next('.height_input');
            var lengthInputs = item.next('.length_input');
            var nbRow = lengthInputs.childElementCount;
            var lastIndex;
            if(lengthInputs.lastElementChild) {
                lastIndex = lengthInputs.lastElementChild.readAttribute('position');
            } else {
                lastIndex = 0;
            }

            if (nbAsked > nbRow) {
                for (var j = 0; j < (nbAsked - nbRow); j++) {
                    weightInputs.appendChild(createButton('weight', lastIndex, weight));
                    widthInputs.appendChild(createButton('width', lastIndex));
                    heightInputs.appendChild(createButton('height', lastIndex));
                    lengthInputs.appendChild(createButton('length', lastIndex));
                    lastIndex ++;
                }
            } else if (nbAsked < nbRow) {
                var cpt = nbRow - nbAsked;
                while (cpt > 0 && weightInputs.lastChild) {
                    weightInputs.lastChild.remove();
                    widthInputs.lastChild.remove();
                    heightInputs.lastChild.remove();
                    lengthInputs.lastChild.remove();
                    cpt--;
                }
            }
        }

        function createButton(type, lastIndex, weight) {
            var input = document.createElement('input');
            input.setAttribute('name', type + '_input');
            input.setAttribute('class', 'input-text');
            input.setAttribute('position', parseInt(lastIndex) + 1);
            input.setStyle({marginBottom: '5px'});
            input.setAttribute('value', '1');
            if (weight) {
                input.setAttribute('value', weight);
            }
            setEventChange(input);
            return input;
        }

        function setSubmitFormFunction() {
            var formExpedition = $(item).next('.etiquette_expedition').down('form');
            do {
                if(formExpedition.down('a')) {
                    formExpedition.down('a').observe('click', function(a) {
                        submitForm($(item).up().down('.order_id').innerHTML.trim(), Event.element(a));
                    });
                }
                formExpedition = formExpedition.next('form');
            } while (formExpedition);
        }

        function submitForm(order_increment_id, link) {
            if($$('.messages .id-' + order_increment_id).length !== 0 || !correctDimensions(false)) {
                correctDimensions(true);
                return false;
            } else {
                link.up().submit();
            }
        }
    });

    function addLiErrorDimensions(orderId, typeError, limitWeight, limitInputsDimensions, limitTotalDimensions) {
        var ul = $$('.messages');
        var ulCreated = false;
        if(ul.length === 0){
            ulCreated = true;
            ul = document.createElement('ul');
            ul.setAttribute('class', 'messages');
        } else {
            ul = ul[0];
        }
        var li = document.createElement('li');
        li.setAttribute('class', 'error-msg id-'+orderId + ' ' + typeError);
        var span = document.createElement('span');
        var errorMsg;
        switch (typeError) {
            case "weight":
                errorMsg = Translator.translate('One or several packages are above the weight limit (%s kg)').replace('%s', limitWeight) + ' (' + Translator.translate("Order %s").replace('%s', orderId) + ')';
                break;
            case "length" :
                errorMsg = Translator.translate('One or several packages are above the size limit (%s cm)').replace('%s', limitInputsDimensions) + ' (' + Translator.translate("Order %s").replace('%s', orderId) + ')';
                break;
            case "global" :
                errorMsg = Translator.translate('One or several packages are above the total (L+2H+2l) size limit (%s cm)').replace('%s', limitTotalDimensions) + ' (' + Translator.translate("Order %s").replace('%s', orderId) + ')';
                break;
        }
        var containerErrorMsg = document.createTextNode(errorMsg);
        span.appendChild(containerErrorMsg);
        li.appendChild(span);
        if($$('.id-' + orderId + '.' + typeError).length === 0) {
            ul.appendChild(li);
            if(ulCreated && $$('.id-' + orderId).length === 0) {
                $('messages').appendChild(ul);
            }
        }
    }

    function removeLiErrorDimensions(orderId, typeError) {
        if($$('.id-' + orderId+'.'+typeError).length !== 0) {
            $$('.id-' + orderId+'.'+typeError).forEach(function(e) {
                e.remove();
            })
        }
    }

    function buildDimensionsObject(item) {
        var dimensions = {};

        var weights = item.next('.weight_input').childElements();
        var widths = item.next('.width_input').childElements();
        var heights = item.next('.height_input').childElements();
        var lengths = item.next('.length_input').childElements();

        for (var i = 0; i < weights.length; i++) {
            var dimension = {};
            dimension.weight = weights[i].value;
            dimension.width = widths[i].value;
            dimension.height = heights[i].value;
            dimension.length = lengths[i].value;
            dimensions[i] = dimension;
        }
        return JSON.stringify(dimensions);
    }


    // rewrite GridMassaction in order to pass custom data in post
    varienGridMassaction.prototype.apply = function () {
        if (varienStringArray.count(this.checkedString) == 0) {
            alert(this.errorText);
            return;
        }

        var item = this.getSelectedItem();
        if (!item) {
            this.validator.validate();
            return;
        }
        this.currentItem = item;
        var fieldName = (item.field ? item.field : this.formFieldName);

        if (this.currentItem.confirm && !window.confirm(this.currentItem.confirm)) {
            return;
        }

        this.formHiddens.update('');
        new Insertion.Bottom(this.formHiddens, this.fieldTemplate.evaluate({
            name: fieldName,
            value: this.checkedString
        }));
        new Insertion.Bottom(this.formHiddens, this.fieldTemplate.evaluate({
            name: 'massaction_prepare_key',
            value: fieldName
        }));

        // collect all datas of grid to post it
        new Insertion.Bottom(this.formHiddens, this.fieldTemplate.evaluate({
            name: 'contracts_ids',
            value: Form.serializeElements($$('#sales_order_grid' + ' .grid .contract_expedition select'))
        }));
        new Insertion.Bottom(this.formHiddens, this.fieldTemplate.evaluate({
            name: 'numbers_parcels',
            value: Form.serializeElements($$('#sales_order_grid' + ' .grid .number_parcel input'))
        }));
        new Insertion.Bottom(this.formHiddens, this.fieldTemplate.evaluate({
            name: 'all_dimensions',
            value: Form.serializeElements($$('#sales_order_grid' + ' .grid .etiquette_expedition form input.container'))
        }));

        if (!this.validator.validate()) {
            return;
        }

        if (this.useAjax && item.url) {
            new Ajax.Request(item.url, {
                'method': 'post',
                'parameters': this.form.serialize(true),
                'onComplete': this.onMassactionComplete.bind(this)
            });
        } else if (item.url) {
            if (item.target) {
                switch (item.target) {
                    case '_blank':
                        this.form.target = '_blank';
                        break;
                    default:
                        this.form.target = '';
                        break;
                }
            }
            this.form.action = item.url;
            this.form.submit();
            this.form.target = '';
        }
    };
});
